// Code generated by "enumer -type=OfficeType -json -text -yaml -sql"; DO NOT EDIT.

//
package officeTypes

import (
	"database/sql/driver"
	"encoding/json"
	"fmt"
)

const _OfficeTypeName = "NAMidnightOfficeMatinsGreatHoursFirstHourThirdHourSixthHourTypikaLiturgyReaderServiceMolebenSlavaNinthHourVespersPresanctifiedSmallVespersVesperalLiturgyGreatComplineComplineSalutationsMatinsInEvening"

var _OfficeTypeIndex = [...]uint8{0, 2, 16, 22, 32, 41, 50, 59, 65, 72, 85, 92, 97, 106, 113, 126, 138, 153, 166, 174, 185, 200}

func (i OfficeType) String() string {
	if i < 0 || i >= OfficeType(len(_OfficeTypeIndex)-1) {
		return fmt.Sprintf("OfficeType(%d)", i)
	}
	return _OfficeTypeName[_OfficeTypeIndex[i]:_OfficeTypeIndex[i+1]]
}

var _OfficeTypeValues = []OfficeType{0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20}

var _OfficeTypeNameToValueMap = map[string]OfficeType{
	_OfficeTypeName[0:2]:     0,
	_OfficeTypeName[2:16]:    1,
	_OfficeTypeName[16:22]:   2,
	_OfficeTypeName[22:32]:   3,
	_OfficeTypeName[32:41]:   4,
	_OfficeTypeName[41:50]:   5,
	_OfficeTypeName[50:59]:   6,
	_OfficeTypeName[59:65]:   7,
	_OfficeTypeName[65:72]:   8,
	_OfficeTypeName[72:85]:   9,
	_OfficeTypeName[85:92]:   10,
	_OfficeTypeName[92:97]:   11,
	_OfficeTypeName[97:106]:  12,
	_OfficeTypeName[106:113]: 13,
	_OfficeTypeName[113:126]: 14,
	_OfficeTypeName[126:138]: 15,
	_OfficeTypeName[138:153]: 16,
	_OfficeTypeName[153:166]: 17,
	_OfficeTypeName[166:174]: 18,
	_OfficeTypeName[174:185]: 19,
	_OfficeTypeName[185:200]: 20,
}

// OfficeTypeString retrieves an enum value from the enum constants string name.
// Throws an error if the param is not part of the enum.
func OfficeTypeString(s string) (OfficeType, error) {
	if val, ok := _OfficeTypeNameToValueMap[s]; ok {
		return val, nil
	}
	return 0, fmt.Errorf("%s does not belong to OfficeType values", s)
}

// OfficeTypeValues returns all values of the enum
func OfficeTypeValues() []OfficeType {
	return _OfficeTypeValues
}

// IsAOfficeType returns "true" if the value is listed in the enum definition. "false" otherwise
func (i OfficeType) IsAOfficeType() bool {
	for _, v := range _OfficeTypeValues {
		if i == v {
			return true
		}
	}
	return false
}

// MarshalJSON implements the json.Marshaler interface for OfficeType
func (i OfficeType) MarshalJSON() ([]byte, error) {
	return json.Marshal(i.String())
}

// UnmarshalJSON implements the json.Unmarshaler interface for OfficeType
func (i *OfficeType) UnmarshalJSON(data []byte) error {
	var s string
	if err := json.Unmarshal(data, &s); err != nil {
		return fmt.Errorf("OfficeType should be a string, got %s", data)
	}

	var err error
	*i, err = OfficeTypeString(s)
	return err
}

// MarshalText implements the encoding.TextMarshaler interface for OfficeType
func (i OfficeType) MarshalText() ([]byte, error) {
	return []byte(i.String()), nil
}

// UnmarshalText implements the encoding.TextUnmarshaler interface for OfficeType
func (i *OfficeType) UnmarshalText(text []byte) error {
	var err error
	*i, err = OfficeTypeString(string(text))
	return err
}

// MarshalYAML implements a YAML Marshaler for OfficeType
func (i OfficeType) MarshalYAML() (interface{}, error) {
	return i.String(), nil
}

// UnmarshalYAML implements a YAML Unmarshaler for OfficeType
func (i *OfficeType) UnmarshalYAML(unmarshal func(interface{}) error) error {
	var s string
	if err := unmarshal(&s); err != nil {
		return err
	}

	var err error
	*i, err = OfficeTypeString(s)
	return err
}

func (i OfficeType) Value() (driver.Value, error) {
	return i.String(), nil
}

func (i *OfficeType) Scan(value interface{}) error {
	if value == nil {
		return nil
	}

	str, ok := value.(string)
	if !ok {
		bytes, ok := value.([]byte)
		if !ok {
			return fmt.Errorf("value is not a byte slice")
		}

		str = string(bytes[:])
	}

	val, err := OfficeTypeString(str)
	if err != nil {
		return err
	}

	*i = val
	return nil
}
